/****************************************************************************
				Program INtegrity CHecker
				for NetWare 3.x
				Copyright 1992, Novell, Inc.

				Morgan B. Adair
				Novell Systems Research

				LOG.C			Functions to manage log file/screen
*****************************************************************************/

#include <stdio.h>
#include <conio.h>
#include "log.h"

int	myScreen;
char	screenName[] = "PINCH File Scan Screen";
int	row;
FILE *logFile;

void OpenLog(void)
{
	myScreen = CreateScreen(&screenName, AUTO_DESTROY_SCREEN);
	row = 1;
	logFile = fopen(LOGFILE_NAME, "at");
}

void CloseLog(void)
{
	SetCurrentScreen(myScreen);
	DestroyScreen(myScreen);
	fclose(logFile);
}

void LogFileChange(DIR *directoryEntry, FILE_ENTRY *entry, unsigned crc)
{
	short	dateTime[2];
	char	oldTimeStr[18];
	char	newTimeStr[18];
	char	buf[128];

	dateTime[1] = entry->modificationTime;
	dateTime[0] = entry->modificationDate;
	DecodeDateAndTime((char *)dateTime, oldTimeStr);

	dateTime[1] = directoryEntry->d_time;
	dateTime[0] = directoryEntry->d_date;
	DecodeDateAndTime((char *)dateTime, newTimeStr);

	LogMessage("File data changed:\n");
	sprintf(buf, "     File: %s\n", entry->pathName);
	LogMessage(buf);
	sprintf(buf, "     old modified time = %s\n", oldTimeStr);
	LogMessage(buf);
	sprintf(buf, "     new modified time = %s\n", newTimeStr);
	LogMessage(buf);
	sprintf(buf, "     old file size     = %ld\n", directoryEntry->d_size);
	LogMessage(buf);
	sprintf(buf, "     new file size     = %ld\n", entry->fileSize);
	LogMessage(buf);
	sprintf(buf, "     old modifier ID   = %lu\n", directoryEntry->d_updatedID);
	LogMessage(buf);
	sprintf(buf, "     new modifier ID   = %lu\n", entry->lastModifierID);
	LogMessage(buf);
	sprintf(buf, "     old CRC           = %04X\n", entry->crc);
	LogMessage(buf);
	sprintf(buf, "     new CRC           = %04X\n", crc);
	LogMessage(buf);
}

void LogMessage(char *string)
{
	EnterCritSec();
	SetCurrentScreen(myScreen);
	gotoxy(0, row++);
	printf("%s\r", string);
	ExitCritSec();
	ThreadSwitch();

	if (row > 25)
		row = 25;

	fputs(string, logFile);
}

