/****************************************************************************
				Program INtegrity CHecker
				for NetWare 3.x
				Copyright 1992, Novell, Inc.

				Morgan B. Adair
				Novell Systems Research

				SCREEN.C		Thread to update main screen
*****************************************************************************/

#include <conio.h>
#include <stdio.h>
#include <process.h>
#include <time.h>
#include "pinch.h"

extern short programStatus;
extern short runMode;
extern BYTE threadCount;
extern int mainScreen;
extern time_t currentTime;
extern time_t wakeUpTime;

void ClearScreenRow(int row);

void UpdateScreen(void)
{
	threadCount++;

	while (programStatus != EXITING) {

		currentTime = time(NULL);

		EnterCritSec();
		SetCurrentScreen(mainScreen);

		gotoxy(28, 2);
		printf("Program Integrity Checker");

		gotoxy(55, 4);
		printf("%s", ctime(&currentTime));

		gotoxy(0, 6);
		printf("");

		ClearScreenRow(10);
		gotoxy(0, 10);
		switch (programStatus) {
					case	RUNNING	:	printf("\tStatus:  Checking integrity of program files");
											break;

					case	WAITING	:	printf("\tStatus:  Waiting to begin running at %s", ctime(&wakeUpTime));
											break;

					case	STOPPED	:	printf("\tPlease select an operating mode, or press Esc to exit");
		}

		/* give another process a chance */
		ExitCritSec();
		ThreadSwitch();

		EnterCritSec();
		SetCurrentScreen(mainScreen);

		ClearScreenRow(12);
		ClearScreenRow(13);
		ClearScreenRow(14);
		ClearScreenRow(15);
		gotoxy(0, 12);
		if (programStatus == STOPPED) {
			printf("\t1. Run now.\n");
			printf("\t2. Run hourly.\n");
			printf("\t3. Run daily.\n");
			printf("\t4. Run constantly.\n");
		} else {
			printf("\tMode selected:  ");
			switch (runMode) {
						case	NOW			:	printf("Run now\n");
													break;

						case	HOURLY		:	printf("Run hourly\n");
													break;

						case	DAILY			:	printf("Run daily\n");
													break;

						case	CONSTANT		:	printf("Run constantly\n");
													break;
			}
		}

		ExitCritSec();
		delay(500);
	}
	threadCount--;
	return;
}

void ClearScreenRow(int	row)
{
 	gotoxy(0, row);
	printf("                                                                                ");
}

